| # |
| # Copyright 2016 the original author or authors. |
| # |
| # Licensed under the Apache License, Version 2.0 (the "License"); |
| # you may not use this file except in compliance with the License. |
| # You may obtain a copy of the License at |
| # |
| # http://www.apache.org/licenses/LICENSE-2.0 |
| # |
| # Unless required by applicable law or agreed to in writing, software |
| # distributed under the License is distributed on an "AS IS" BASIS, |
| # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| # See the License for the specific language governing permissions and |
| # limitations under the License. |
| # |
| |
| # set default shell |
| SHELL = bash -e -o pipefail |
| |
| # Variables |
| VERSION ?= $(shell cat ./VERSION) |
| |
| DOCKER_EXTRA_ARGS ?= |
| DOCKER_REGISTRY ?= |
| DOCKER_REPOSITORY ?= |
| DOCKER_TAG ?= ${VERSION} |
| IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}openolt-scale-tester:${DOCKER_TAG} |
| |
| # Default is GO111MODULE=auto, which will refuse to use go mod if running |
| # go less than 1.13.0 and this repository is checked out in GOPATH. For now, |
| # force module usage. This affects commands executed from this Makefile, but |
| # not the environment inside the Docker build (which does not build from |
| # inside a GOPATH). |
| export GO111MODULE=on |
| |
| DOCKER_BUILD_ARGS ?= \ |
| ${DOCKER_EXTRA_ARGS} \ |
| |
| .PHONY: docker-build local-protos local-lib-go |
| |
| # This should to be the first and default target in this Makefile |
| help: |
| @echo "Usage: make [<target>]" |
| @echo "where available targets are:" |
| @echo "" |
| @echo "clean : Removes any local filesystem artifacts generated by a build" |
| @echo "distclean : Removes any local filesystem artifacts generated by a build or test run" |
| @echo "build : Build all openolt adapter artifacts" |
| @echo "docker-build : Build openolt adapter docker image" |
| @echo "docker-push : Push the docker images to an external repository" |
| @echo "help : Print this help" |
| @echo "lint : Run all lint targets" |
| @echo "lint-mod : Verify the Go dependencies" |
| @echo "lint-sanity : Run the Go language sanity tests (vet)" |
| @echo "lint-style : Verify the Go standard format of the source" |
| @echo "sca : Runs various SCA through golangci-lint tool" |
| @echo "test : Run unit tests, if any" |
| @echo |
| |
| ## Docker targets |
| |
| build: docker-build |
| |
| docker-build: local-protos local-lib-go |
| go mod vendor |
| go build -mod=vendor |
| docker build $(DOCKER_BUILD_ARGS) -t ${IMAGENAME} -f docker/Dockerfile . |
| |
| docker-push: |
| docker push ${IMAGENAME} |
| |
| lint-style: |
| ifeq (,$(shell which gofmt)) |
| go get -u github.com/golang/go/src/cmd/gofmt |
| endif |
| @echo "Running style check..." |
| @gofmt_out="$$(gofmt -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\ |
| if [ ! -z "$$gofmt_out" ]; then \ |
| echo "$$gofmt_out" ;\ |
| echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\ |
| exit 1 ;\ |
| fi |
| @echo "Style check OK" |
| |
| lint-sanity: |
| @echo "Running sanity check..." |
| @go vet -mod=vendor ./... |
| @echo "Sanity check OK" |
| |
| lint-mod: |
| @echo "Running dependency check..." |
| @go mod verify |
| @echo "Dependency check OK. Running vendor check..." |
| @git status > /dev/null |
| @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1) |
| @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1) |
| go mod tidy |
| go mod vendor |
| @git status > /dev/null |
| @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1) |
| @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1) |
| @echo "Vendor check OK." |
| |
| lint: lint-style lint-sanity lint-mod |
| |
| __GOPATH=$(shell go env GOPATH) |
| |
| # Rules to automatically install golangci-lint |
| GOLANGCI_LINT_TOOL?=$(shell which golangci-lint) |
| ifeq (,$(GOLANGCI_LINT_TOOL)) |
| GOLANGCI_LINT_TOOL=$(__GOPATH)/bin/golangci-lint |
| golangci_lint_tool_install: |
| # Same version as installed by Jenkins ci-management |
| # Note that install using `go get` is not recommended as per https://github.com/golangci/golangci-lint |
| curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh| sh -s -- -b $(__GOPATH)/bin v1.17.0 |
| else |
| golangci_lint_tool_install: |
| endif |
| |
| # Rules to automatically install go-junit-report |
| GO_JUNIT_REPORT?=$(shell which go-junit-report) |
| ifeq (,$(GO_JUNIT_REPORT)) |
| GO_JUNIT_REPORT=$(__GOPATH)/bin/go-junit-report |
| go_junit_install: |
| go get -u github.com/jstemmer/go-junit-report |
| else |
| go_junit_install: |
| endif |
| |
| # Rules to automatically install gocover-covertura |
| GOCOVER_COBERTURA?=$(shell which gocover-cobertura) |
| ifeq (,$(GOCOVER_COBERTURA)) |
| @GOCOVER_COBERTURA=$(__GOPATH)/bin/gocover-cobertura |
| gocover_cobertura_install: |
| go get -u github.com/t-yuki/gocover-cobertura |
| else |
| gocover_cobertura_install: |
| endif |
| |
| test: go_junit_install gocover_cobertura_install |
| @mkdir -p ./tests/results |
| |
| go mod vendor |
| go build -mod=vendor |
| |
| @go test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\ |
| RETURN=$$? ;\ |
| $(GO_JUNIT_REPORT) < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\ |
| $(GOCOVER_COBERTURA) < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\ |
| exit $$RETURN |
| |
| GOLANGCI_LINT_TOOL:=$(shell which golangci-lint) |
| sca: golangci_lint_tool_install |
| @mkdir -p ./sca-report |
| golangci-lint run --out-format junit-xml ./... 2>&1 | tee ./sca-report/sca-report.xml |
| |
| clean: |
| |
| distclean: clean |
| rm -rf ./sca_report |
| |
| # end file |